/*
 *      file I/O version of forward ref handler
 */

#define	FILEMODE	0644    /* file creat mode */
#define	UPDATE		2       /* file open mode */
#define	ABS		0       /* absolute seek */

/*
 *      fwdinit --- initialize forward ref file
 */
void fwdinit (void) {
  /* You know, there's really no reason that this couldn't be done
     using stdio fopen/fclose etc. Just remember to use mode "wb" */
  Forward = creat (Fwd_name, FILEMODE);
  if (Forward < 0)
    fatal ("Can't create temp file \"%s\"", Fwd_name);
  close (Forward);              /* close and reopen for reads and writes */
  Forward = open (Fwd_name, UPDATE);
  if (Forward < 0)
    fatal ("Forward ref file \"%s\" has gone.", Fwd_name);

}

void fwdterminate (void) {
  if (Forward > 0) close(Forward);
  Forward = -1;
}

/*
 *      fwdreinit --- reinitialize forward ref file
 */
void fwdreinit (void) {
  int rc;

  F_ref = 0;
  Ffn = 0;
  lseek (Forward, 0L, ABS);     /* rewind forward refs */
  rc = read (Forward, &Ffn, sizeof (Ffn));
  if (rc < 0) {
    fatal ("Error re-reading forward refs file - %s", strerror (errno));
  } else if (rc == 0) {

  } else if (rc < sizeof (Ffn)) {
    fatal ("Failed to read all data from forward refs file.  Got %d of %d bytes", rc, sizeof (Ffn));
  }
  rc = read (Forward, &F_ref, sizeof (F_ref));  /* read first forward ref into mem */
  if (rc < 0) {
    fatal ("Error writing to forward refs file - %s", strerror (errno));
  } else if (rc == 0) {

  } else if (rc < sizeof (F_ref)) {
    fatal ("Failed to write all data to forward refs file - wrote %d of %d bytes", rc, sizeof (F_ref));
  }
  
  if (DEBUG) {
    fprintf (stderr, "First fwd ref: %d,%d\n", Ffn, F_ref);
  }
}

/*
 *      fwdmark --- mark current file/line as containing a forward ref
 */
void fwdmark (void) {
  int rc;

  rc = write (Forward, &Cfn, sizeof (Cfn));
  if (rc < 0) {
    fatal ("Error writing forward refs file - %s", strerror (errno));
  } else if (rc < sizeof (Cfn)) {
    fatal ("Failed to write all data to forward refs file - wrote %d of %d bytes", rc, sizeof (Cfn));
  }
  rc = write (Forward, &Line_num, sizeof (Line_num));
  if (rc < 0) {
    fatal ("Error writing to forward refs file - %s", strerror (errno));
  } else if (rc < sizeof (Line_num)) {
    fatal ("Failed to write all data to forward refs file - wrote %d of %d bytes", rc, sizeof (Line_num));
  }
}

/*
 *      fwdnext --- get next forward ref
 */
void fwdnext (void) {
  int stat;

  stat = read (Forward, &Ffn, sizeof (Ffn));

  if (DEBUG) {
    fprintf (stderr, "Ffn stat=%d ", stat);
  }

  stat = read (Forward, &F_ref, sizeof (F_ref));

  if (DEBUG) {
    fprintf (stderr, "F_ref stat=%d  ", stat);
  }

  if (stat < 2) {
    F_ref = 0;
    Ffn = 0;
  }

  if (DEBUG) {
    fprintf (stderr, "Next Fwd ref: %d,%d\n", Ffn, F_ref);
  }
}
